
; stage 1 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

; stage name

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,1+1
	
	.byte 0,0,0,0
	.byte +$ca,"MOOT"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte 0

; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte ~10000000

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,8,6,6

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,128,128,128,128,dragseg1a,drag1a,triadc
	.byte triadb,triada,bush,ship,tree,rock,fireball,oval,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 62-40,62-20,62,64,66,68,70,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

;sky_colour		.ds 40

	.byte 96+8
	.byte 96+8,96+8,96+10,96+12,176+8,176+10,176+12,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0
	
; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 176+9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour2		.ds 24

	.byte 176+11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte 0
	.byte bush*4
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 3
	.byte 107-3			; *0
	.byte 0,0,0,0,0,0,0,0		; 107 - 53.5
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte tree*4
	.byte rock*4
	.byte tree*4
	.byte 0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 2+3			; *0
	.byte 4				; 2 - 1
	.byte 8				; *6 - 3
	.byte 2				; 12 - 6
	.byte 12			; *14 - 7
	.byte 4				; 26 - 13
	.byte 13			; *30 - 15
	.byte 2				; 43 - 21.5
	.byte 4				; *45 - 22.5
	.byte 4				; 49 - 24.5
	.byte 6				; *53 - 26.5
	.byte 2				; 55 - 27.5
	.byte 2				; *57 - 28.5
	.byte 2				; 59 - 29.5				; 				; 
	.byte 2				; 61 - 30.5
	.byte 46-3			; 63 - 31.5
	.byte 0,0,0,0			; 109 - 54.5 
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 10			; *0
	.byte 12			; 10 - 5
	.byte 14			; 22 - 11
	.byte 3				; 36 - 18
	.byte 13			; 39 - 19.5
	.byte 0				; 52 - 26
	.byte 0				; 52 - 26
	.byte 18			; 52 - 26
	.byte 14			; 70 - 35
	.byte 0				; 84 - 42
	.byte 13			; 84 - 42
	.byte 0				; 97 - 48.5
	.byte 0				; 97 - 48.5
	.byte 22			; 97 - 48.5
	.byte 1				; 119 - 59.5
	.byte 0				; 
	.byte 255			; wait
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-18] 0


; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte spread_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 1				; priority swap pattern command
	.byte animate_bit
	.byte link_bit+animate_bit
	.byte 0
	.dc [max_patterns-18] 0

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat1-pat0]
	.byte <[pat2-pat0]
	.byte <[pat3-pat0]
	.byte <[pat3-pat0]
	.byte <[pat4-pat0]
	.byte <[pat4-pat0]
	.byte <[pat5-pat0]
	.byte <[pat6-pat0]
	.byte <[pat7-pat0]
	.byte <[pat7-pat0]
	.byte <[pat4-pat0]
	.byte <[pat4-pat0]
	.byte <[pat5-pat0]
	.byte 2				; init boss
	.byte <[pat8-pat0]
	.byte <[pat9-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-18] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat1-pat0]*8+6-1
	.byte >[pat2-pat0]*8+3-1
	.byte >[pat3-pat0]*8+4-1
	.byte >[pat3-pat0]*8+4-1
	.byte >[pat4-pat0]*8+1-1
	.byte >[pat4-pat0]*8+1-1
	.byte >[pat5-pat0]*8+1-1
	.byte >[pat6-pat0]*8+4-1
	.byte >[pat7-pat0]*8+3-1
	.byte >[pat7-pat0]*8+3-1
	.byte >[pat4-pat0]*8+1-1
	.byte >[pat4-pat0]*8+1-1
	.byte >[pat5-pat0]*8+1-1
	.byte music_bank_offset+2	; song (squilla)
	.byte >[pat8-pat0]*8+1-1
	.byte >[pat9-pat0]*8+7-1
	.byte 0
	.dc [max_patterns-18] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte ship
	.byte ship
	.byte ship
	.byte ship
	.byte triada
	.byte triada
	.byte triada
	.byte ship
	.byte ship
	.byte ship
	.byte triada
	.byte triada
	.byte triada
	.byte 0
	.byte drag1a
	.byte dragseg1a
	.byte 0
	.dc [max_patterns-18] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 3
	.byte 6
	.byte 5
	.byte 5
	.byte 1
	.byte 1
	.byte 1
	.byte 6
	.byte 5
	.byte 5
	.byte 1
	.byte 1
	.byte 1
	.byte 0				; start song line
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 0
	.dc [max_patterns-18] 0

