
; stage 2 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,2+1
	
	.byte 0,0,0
	.byte +$ca,"GEEZA"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte $08

; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte ~10000000

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,8,6,6

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,128,128,128,128,128,128,barbarian
	.byte gremlin,head,pillar,brick,stick,rock,fireball,oval,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 62-40,62-20,62,64,66,68,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

;sky_colour		.ds 40

	.byte 144+8
	.byte 144+8,144+8,112+12,96+12,48+12,48+14,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 224+7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour2		.ds 24

	.byte 224+11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte brick*4
	.byte stick*4
	.byte pillar*4
	.byte stick*4
	.byte 0
	.byte rock*4
	.byte pillar*4
	.byte 0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 20			; 0
	.byte 31			; 20 - 10
	.byte 6				; 51 - 25.5
	.byte 10			; 57 - 28.5
	.byte 7				; *67 - 33.5
	.byte 3				; 74 - 37
	.byte 24			; 77 - 38.5
	.byte 0,0,0			; 101 - 50.5
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte rock*4
	.byte head*4
	.byte 0
	.byte rock*4
	.byte brick*4
	.byte head*4
	.byte rock*4
	.byte brick*4
	.byte rock*4
	.byte brick*4
	.byte rock*4
	.byte head*4
	.byte pillar*4
	.byte 0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 4				; *0
	.byte 7				; 4 - 2
	.byte 4				; 11 - 5.5
	.byte 11			; *15 - 7.5
	.byte 4				; 26 - 13 rock
	.byte 5				; 30 - 15 brick
	.byte 3				; 35 - 17.5 head
	.byte 4				; 38 - 19 rock
	.byte 8				; 42 - 21 brick
	.byte 4				; 50 - 25 rock
	.byte 9				; 54 - 27 brick
	.byte 5				; 63 - 31.5 rock
	.byte 9				; 68 - 34 head
	.byte 23			; 77 - 38.5 pillar
	.byte 0,0,0,0,0,0		; 100 - 50
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 9				; *0
	.byte 5				; 9 - 4.5
	.byte 7				; 14 - 7
	.byte 10			; 21 - 10.5
	.byte 13			; 31 - 15.5
	.byte 0				; 44 - 22
	.byte 14			; 44 - 22
	.byte 11			; 58 - 29
	.byte 15			; 69 - 34.5
	.byte 0				; 84 - 42
	.byte 24			; 84 - 42
	.byte 1				; 108 - 54
	.byte 0
	.byte 0
	.byte 0
	.byte 255			; wait for objects
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-17] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte pat_3d_bit
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte pat_3d_bit
	.byte 0
	.byte 0
	.byte 2				; reset sum loop pattern command
	.byte pat_3d_bit+sum_bit
	.byte pat_3d_bit+link_bit
	.byte pat_3d_bit
	.byte pat_3d_bit+spread_bit
	.byte 0
	.dc [max_patterns-17] 0

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat10-pat0]
	.byte <[pat10-pat0]
	.byte <[pat11-pat0]
	.byte <[pat12-pat0]
	.byte <[pat13-pat0]
	.byte <[pat14-pat0]
	.byte <[pat10-pat0]
	.byte <[pat11-pat0]
	.byte <[pat13-pat0]
	.byte <[pat14-pat0]
	.byte 2				; init boss
	.byte <[pat16-pat0]
	.byte <[pat15-pat0]
	.byte <[pat17-pat0]
	.byte <[pat18-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-17] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat10-pat0]*8+4-1
	.byte >[pat10-pat0]*8+4-1
	.byte >[pat11-pat0]*8+6-1
	.byte >[pat12-pat0]*8+6-1
	.byte >[pat13-pat0]*8+2-1
	.byte >[pat14-pat0]*8+2-1
	.byte >[pat10-pat0]*8+4-1
	.byte >[pat11-pat0]*8+6-1
	.byte >[pat13-pat0]*8+1-1
	.byte >[pat14-pat0]*8+1-1
	.byte music_bank_offset+3	; song (ida)
	.byte >[pat16-pat0]*8+0
	.byte >[pat15-pat0]*8+1-1
	.byte >[pat17-pat0]*8+4-1
	.byte >[pat18-pat0]*8+6-1
	.byte 0
	.dc [max_patterns-17] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte gremlin
	.byte gremlin
	.byte head
	.byte gremlin
	.byte head
	.byte head
	.byte gremlin
	.byte head
	.byte head
	.byte head
	.byte 0
	.byte 255			; this must be non-zero for sum pattern, even if object qty 0
	.byte barbarian
	.byte head
	.byte head
	.byte 0
	.dc [max_patterns-17] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 4
	.byte 4
	.byte 9
	.byte 3
	.byte 24
	.byte 24
	.byte 4
	.byte 10
	.byte 24
	.byte 24
	.byte 0				; start song line
	.byte 0
	.byte 0
	.byte 5
	.byte 3
	.byte 0
	.dc [max_patterns-17] 0
