
; stage 3 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,3+1
	
	.byte 0,0,0,0
	.byte +$ca,"AMAR"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte $18

; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte ~10000000

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,7,6,128

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,128,128,128,128,128,dragseg2a,drag2a
	.byte ship,fly,plantA,mushA,peanut,orange,fireball,oval,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 32-15,32
	.byte 34,36,38,40
	.byte 42,44,46,48
	.byte 50,52,54,56
	.byte 58,60,62,64
	.byte 66,68,70,72
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

;sky_colour		.ds 40

	.byte 4*16+10
	.byte 4*16+10,0+10
	.byte 4*16+10,4*16+12,4*16+10,0+10
	.byte 4*16+10,4*16+12,4*16+10,0+10
	.byte 4*16+10,4*16+12,4*16+10,0+10
	.byte 4*16+10,4*16+12,4*16+10,0+10
	.byte 4*16+10,4*16+12,4*16+10,0+10
	.byte 0,0,0,0,0,0,0,0,0,0	
	.byte 0,0,0,0,0,0,0
	
; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 0+13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour2		.ds 24

	.byte 6*16+13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 128
	
; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte orange*4,0
	.byte plantA*4,plantB*4,plantC*4,0
	.byte orange*4,
	.byte plantA*4,plantB*4,plantC*4
	.byte orange*4
	.byte plantA*4,plantB*4,plantC*4
	.byte orange*4
	.byte plantA*4,plantB*4,plantC*4
	.byte plantA*4,plantB*4,plantC*4
	.byte orange*4
	.byte 0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 4,7			; *0
	.byte 4,3,4,4			; 11 - 5.5
	.byte 5				; 26 - 13
	.byte 4,3,4			; 31 - 15.5
	.byte 9				; 42 - 21
	.byte 4,3,4			; 51 - 25.5
	.byte 9				; 62 - 31
	.byte 3,3,3			; 71 - 35.5
	.byte 3,3,4			; 80 - 40
	.byte 16			; 90 - 45
	.byte 0,0,0,0,0,0,0,0		; 106 - 53
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte mushA*4+1
	.byte peanut*4
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 90			; *0
	.byte 16			; 90 - 45
	.byte 0,0,0,0,0,0,0,0		; 106 - 53 
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 4				; 0
	.byte 5				; 4 - 2
	.byte 12			; 9 - 4.5
	.byte 3				; 21 - 10.5
	.byte 7				; 24 - 12
	.byte 0				; 31 - 15.5
	.byte 7				; 31 - 15.5
	.byte 24			; 38 - 19
	.byte 3				; 62 - 31
	.byte 0				; 65 - 32.5
	.byte 10			; 65 - 32.5
	.byte 6				; 75 - 37.5
	.byte 1				; 81 - 40.5
	.byte 10			; 82 - 41
	.byte 15			; 92 - 46
	.byte 1				; 107 - 53.5
	.byte 1				; 108 - 54
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 255			; wait for drag to finish
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-23] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte x_mirror_bit
	.byte spread_bit
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte spread_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte 0
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+sum_bit+rotate_bit
	.byte 0
	.dc [max_patterns-23] 0

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat19-pat0]
	.byte <[pat3-pat0]
	.byte <[pat20-pat0]
	.byte <[pat20-pat0]
	.byte <[pat21-pat0]
	.byte <[pat21-pat0]
	.byte <[pat22-pat0]
	.byte <[pat3-pat0]
	.byte <[pat23-pat0]
	.byte <[pat23-pat0]
	.byte <[pat22-pat0]
	.byte <[pat23-pat0]
	.byte <[pat23-pat0]
	.byte 10			; set frame rate
	.byte 10			; set frame rate
	.byte 2				; init boss
	.byte <[pat24-pat0]
	.byte <[pat25-pat0]
	.byte <[pat27-pat0]
	.byte <[pat28-pat0]
	.byte <[pat26-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-23] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat19-pat0]*8+3-1
	.byte >[pat3-pat0]*8+3-1
	.byte >[pat20-pat0]*8+3-1
	.byte >[pat20-pat0]*8+3-1
	.byte >[pat21-pat0]*8+3-1
	.byte >[pat21-pat0]*8+3-1
	.byte >[pat22-pat0]*8+3-1
	.byte >[pat3-pat0]*8+3-1
	.byte >[pat23-pat0]*8+1-1
	.byte >[pat23-pat0]*8+1-1
	.byte >[pat22-pat0]*8+3-1
	.byte >[pat23-pat0]*8+4-1
	.byte >[pat23-pat0]*8+4-1
	.byte 1				; 0=25fps, 1=20fps, 2=17fps, 3=15fps, 4=12fps, 5=10fps
	.byte 3				; 0=25fps, 1=20fps, 2=17fps, 3=15fps, 4=12fps, 5=10fps
	.byte music_bank_offset+4	; song (godarni)
	.byte >[pat24-pat0]*8+1-1
	.byte >[pat25-pat0]*8+3-1
	.byte >[pat27-pat0]*8+1-1
	.byte >[pat28-pat0]*8+3-1
	.byte >[pat26-pat0]*8+1
	.byte 0
	.dc [max_patterns-23] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte ship
	.byte ship
	.byte ship
	.byte ship
	.byte ship
	.byte ship
	.byte fly
	.byte ship
	.byte fly
	.byte fly
	.byte fly
	.byte fly
	.byte fly
	.byte 0
	.byte 0
	.byte 0
	.byte drag2a
	.byte dragseg2a
	.byte drag2a
	.byte dragseg2a
	.byte dragseg2a
	.byte 0
	.dc [max_patterns-23] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 3
	.byte 5
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 5
	.byte 0
	.byte 0
	.byte 3
	.byte 13
	.byte 13
	.byte 0
	.byte 0
	.byte 0				; start song line
	.byte 128+2+5*8			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 128+2+5*8			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 0
	.byte 0
	.dc [max_patterns-23] 0


