
; stage 4 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,4+1
	
	.byte 0
	.byte +$ca,"CEICIEL"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte $28
	
; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 2

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte 0

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,6,6,10

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,128,128,128,128,128,128,128
	.byte 128,128,hexagon,robot1A,pylon,ship,rocket,oval,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 24
	.byte 26,28,30,32
	.byte 34,36,38,40
	.byte 42,44,46,48
	.byte 50,52,54,56
	.byte 58,60,62,64
	.byte 66,68,70,72
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0
	
;sky_colour		.ds 40

	.byte 4*16+12						; pink
	.byte 0+10
	.byte 8*16+12,8*16+14,8*16+12,0+10			; blue bar
	.byte 10*16+12,10*16+14,10*16+12,0+10			; green bar
	.byte 4*16+12,4*16+14,4*16+12,0+10			; pink bar
	.byte 8*16+12,8*16+14,8*16+12,0+10			; blue bar
	.byte 10*16+12,10*16+14,10*16+12,0+10			; green bar
	.byte 4*16+12,4*16+14,4*16+12,0+8;10			; pink
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 16

;grid_colour_wrap	.ds 1

	.byte 14

;grid_colour_pause	.ds 24

	.byte 4,4,4,4
	.byte 4,4,4,46
	.byte 8,8,46,8
	.byte 8,8,46,60
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour1		.ds 24

	.byte 3*16+11,2*16+11,1*16+11,15*16+11
	.byte 14*16+11,13*16+11,12*16+11,11*16+11
	.byte 10*16+11,9*16+11,8*16+11,7*16+11
	.byte 6*16+11,5*16+11,4*16+11,4*16+11
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour2		.ds 24

	.byte 11,11,11,11
	.byte 11,11,11,11
	.byte 11,11,11,11
	.byte 11,11,11,11
	.byte 0,0,0,0
	.byte 0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte 0
	.byte hexagon*4
	.byte 0
	.byte [hexagon+1]*4
	.byte 0
	.byte hexagon*4
	.byte 0
	.byte [hexagon+1]*4
	.byte 0
	.byte hexagon*4
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 10
	.byte 2
	.byte 2
	.byte 2
	.byte 9
	.byte 2
	.byte 9
	.byte 4
	.byte 10
	.byte 3
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte pylon*4
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 11			; *0
	.byte 48			; 12 - 6
	.byte 0,0,0,0,0,0,0,0		; 59 - 29.5
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 5				; *0
	.byte 5				; 5 - 2.5
	.byte 9
	.byte 0
	.byte 7				; 16 - 8
	.byte 5
	.byte 0
	.byte 6				; 28 - 14
	.byte 9
	.byte 0
	.byte 5				; 41 - 20.5
	.byte 6
	.byte 0				; 52 - 26
	.byte 0				; 52 - 26
	.byte 10
	.byte 4				; 62 - 31
	.byte 1				; 66 - 33
	.byte 0
	.byte 255			; wait for objects
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-20] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte 0
	.byte pat_3d_bit
	.byte pat_3d_bit+x_mirror_bit+anim_mirror_bit
	.byte 0
	.dc [max_patterns-20] 0	

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte 3				; top grid down
	.byte 6				; set colour
	.byte 6
	.byte <[pat3-pat0]
	.byte 6				; set colour
	.byte 6				; set colour 
	.byte <[pat19-pat0]
	.byte 6				; set colour
	.byte 6				; set colour
	.byte <[pat19-pat0]
	.byte 6				; set colour
	.byte <[pat3-pat0]
	.byte <[pat7-pat0]
	.byte 6				; set colour
	.byte 4				; top grid up
	.byte 2				; init boss
	.byte <[pat29-pat0]
	.byte <[pat29-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-20] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte 0
	.byte 1				; COLPF0b
	.byte 1				; COLPF0b
	.byte >[pat3-pat0]*8+3-1
	.byte 1				; COLPF0b
	.byte 1				; COLPF0b
	.byte >[pat19-pat0]*8+3-1
	.byte 1				; COLPF0b
	.byte 1				; COLPF0b
	.byte >[pat19-pat0]*8+3-1
	.byte 1				; COLPF0b	
	.byte >[pat3-pat0]*8+3-1
	.byte >[pat7-pat0]*8+3-1
	.byte 1				; COLPF0b	
	.byte 0
	.byte music_bank_offset+6	; song (wiwijumbo)
	.byte >[pat29-pat0]*8+3-1
	.byte >[pat29-pat0]*8+3-1
	.byte 0
	.dc [max_patterns-20] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte ship
	.byte 0
	.byte 0
	.byte ship
	.byte 0
	.byte 0
	.byte ship
	.byte 0
	.byte ship
	.byte ship
	.byte 0
	.byte 0
	.byte 0
	.byte robot1A
	.byte robot1B
	.byte 0
	.dc [max_patterns-20] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 0
	.byte gamma_adjust+2		; grey colour
	.byte 7*16+gamma_adjust		; blue colour	
	.byte 4
	.byte 2*16+gamma_adjust+2	; orange colour
	.byte 7*16+gamma_adjust		; blue colour	
	.byte 4
	.byte 12*16+gamma_adjust	; green colour 
	.byte 7*16+gamma_adjust		; blue colour	
	.byte 4
	.byte gamma_adjust+2		; grey colour	
	.byte 4
	.byte 4
	.byte 7*16+gamma_adjust		; blue colour	
	.byte 0
	.byte $10			; song start line
	.byte 12
	.byte 12
	.byte 0
	.dc [max_patterns-20] 0

