
; stage 6 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,6+1
	
	.byte 0,0
	.byte +$ca,"OLISIS"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte 8
	
; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte 128

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,6,6,8

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,ballB,ballA,jetB,jetA,robot1A,planeA,ship,
	.byte bugB,bugA,rock,brick,tower,antenna,oval,rocket,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 22,24,27,29
	.byte 32,34,37,39,42,44,47,49
	.byte 52,54,57,59,62,64,67,69
	.byte 72,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0

;sky_colour		.ds 40

	.byte 6*16+12
	.byte 0+10,6*16+10,0+10,6*16+10
	.byte 0+10,6*16+10,0+8,6*16+8,0+8,6*16+8,0+8,6*16+8
	.byte 0+6,6*16+6,0+6,6*16+6,0+6,6*16+6,0+4,6*16+4
	.byte 0+4,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 12,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour2		.ds 24

	.byte 10,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte antenna*4
	.byte 0
	.byte antenna*4+2
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte antenna*4
	.byte 0
	.byte antenna*4
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte antenna*4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 9
	.byte 3
	.byte 3
	.byte 14
	.byte 20
	.byte 15
	.byte 3
	.byte 18
	.byte 3
	.byte 3
	.byte 4
	.byte 2
	.byte 5
	.byte 1
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte rock*4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 5
	.byte 4
	.byte 19
	.byte 4
	.byte 13
	.byte 4
	.byte 4
	.byte 4
	.byte 17
	.byte 4
	.byte 9
	.byte 4
	.byte 1
	.byte 4
	.byte 3
	.byte 4
	.byte 3
	.byte 4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 10			; *0
	.byte 9				; 10 - 5
	.byte 5				; 19 - 9.5
	.byte 11			; 24 - 12
	.byte 5				; 35 - 17.5
	.byte 9				; 40 - 20
	.byte 3				; 49 - 24.5
	.byte 8				; 52 - 26
	.byte 7				; 60 - 30
	.byte 16			; 67 - 33.5
	.byte 1				; 83 - 41.5
	.byte 15			; 84 - 42
	.byte 1				; 99 - 49.5
	.byte 9				; 100 - 50
	.byte 6				; 109 - 54.5
	.byte 1				; 115 = 57.5
	.byte 2				; 115 = 57.5
	.byte 255			; wait for objects
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-19] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0	
	.byte 0	
	.byte 0	
	.byte 0
	.byte pat_3d_bit
	.byte spread_bit
	.byte spread_bit
	.byte 0
	.byte 0
	.byte pat_3d_bit
	.byte 0
	.byte pat_3d_bit+x_mirror_bit+anim_mirror_bit
	.byte 0
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.dc [max_patterns-19] 0	

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat31-pat0]
	.byte <[pat32-pat0]
	.byte <[pat32-pat0]	
	.byte <[pat33-pat0]
	.byte <[pat34-pat0]
	.byte <[pat32-pat0]
	.byte <[pat35-pat0]
	.byte <[pat36-pat0]	
	.byte <[pat36-pat0]
	.byte <[pat33-pat0]
	.byte <[pat34-pat0]
	.byte <[pat35-pat0]
	.byte <[pat31-pat0]
	.byte <[pat29-pat0]
	.byte 2				; init boss
	.byte <[pat37-pat0]
	.byte <[pat37-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-19] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat31-pat0]*8+6-1
	.byte >[pat32-pat0]*8+3-1
	.byte >[pat32-pat0]*8+3-1
	.byte >[pat33-pat0]*8+3-1
	.byte >[pat34-pat0]*8+3-1
	.byte >[pat32-pat0]*8+3-1
	.byte >[pat35-pat0]*8+2-1
	.byte >[pat36-pat0]*8+3-1
	.byte >[pat36-pat0]*8+3-1
	.byte >[pat33-pat0]*8+3-1
	.byte >[pat34-pat0]*8+3-1
	.byte >[pat35-pat0]*8+3-1
	.byte >[pat31-pat0]*8+3-1
	.byte >[pat29-pat0]*8+1-1
	.byte music_bank_offset+6	; song (wiwijumbo)
	.byte >[pat37-pat0]*8+4-1
	.byte >[pat37-pat0]*8+4-1
	.byte 0
	.dc [max_patterns-19] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte bugA
	.byte planeB
	.byte planeA
	.byte planeA
	.byte planeB
	.byte planeA
	.byte robot1A
	.byte jetA
	.byte jetA
	.byte planeA
	.byte planeB
	.byte robot1A
	.byte bugA
	.byte robot2B
	.byte 0
	.byte ballA
	.byte ballA
	.byte 0
	.dc [max_patterns-19] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 3
	.byte 8
	.byte 8
	.byte 8
	.byte 8
	.byte 8
	.byte 9
	.byte 8
	.byte 8
	.byte 16
	.byte 16
	.byte 3
	.byte 3
	.byte 0
	.byte $12			; song start line
	.byte 9
	.byte 9
	.byte 0
	.dc [max_patterns-19] 0

