
; stage 8 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte 0
	.byte +$ca,"STAGE"
	.byte 0,8+1
	
	.byte 0,0,0,0,0
	.byte +$ca,"IDA"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte $08
	
; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte 128

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,6,6,10

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,syura,tallrock,robot4A,triadC,triadB,triadA,robot1A,ship,head
	.byte pillar,brick,stick,bush,rock,rocket,fireball,oval,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (74-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 22
	.byte 25,27,29,31,33,35
	.byte 37,39,41,43,45,47
	.byte 49,50,51,53,54,55
	.byte 57,58,59,60,61,62
	.byte 63,64,66,67
	.byte 68,69,70,71
	.byte 72,73
	.byte 0,0,0,0

;sky_colour		.ds 40

	.byte 11*16+10						; green
	.byte 11*16+6
	.byte 11*16+8,11*16+10,11*16+12,11*16+10,11*16+8,11*16+6; green bar
	.byte 11*16+8,11*16+10,11*16+12,11*16+10,11*16+8,11*16+6; green bar
	.byte 11*16+8,11*16+10,11*16+12,11*16+10,11*16+8,11*16+6; green bar
	.byte 11*16+8,11*16+10,11*16+12,11*16+10,11*16+8,11*16+6; green bar
	.byte 11*16+8,11*16+10,11*16+8,11*16+6			; green bar
	.byte 11*16+8,11*16+10,11*16+8,11*16+6			; green bar
	.byte 11*16+8,11*16+6
	.byte 0,0,0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 14*16+8,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour2		.ds 24

	.byte 14*16+12,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte 0
	.byte rock*4
	.byte bush*4
	.byte rock*4
	.byte bush*4
	.byte rock*4
	.byte brick*4
	.byte bush*4
	.byte rock*4
	.byte bush*4
	.byte 0
	.byte bush*4
	.byte 0
	.byte bush*4
	.byte 0
	.byte rock*4
	.byte brick*4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 3
	.byte 3
	.byte 22
	.byte 2
	.byte 11
	.byte 1
	.byte 4
	.byte 10
	.byte 2
	.byte 1
	.byte 7
	.byte 1
	.byte 4
	.byte 1
	.byte 3
	.byte 1
	.byte 9
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte stick*4
	.byte brick*4
	.byte stick*4
	.byte pillar*4
	.byte stick*4
	.byte rock*4
	.byte 0
	.byte pillar*4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 29
	.byte 13
	.byte 5
	.byte 9
	.byte 25
	.byte 2
	.byte 4
	.byte 14
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 8				; *0
	.byte 0				; 8 - 4
	.byte 21			; 8 - 4
	.byte 1				; 29 - 14.5
	.byte 4				; 30 - 15
	.byte 11			; 34 - 17			
	.byte 1				; 45 - 22.5		
	.byte 1				; 46 - 23 
	.byte 16			; 47 - 23.5
	.byte 0				; 63 - 31.5
	.byte 0				; 63 - 31.5		
	.byte 17			; 63 - 31.5
	.byte 0				; 80 - 40
	.byte 3				; 80 - 40	
	.byte 11			; 83 - 41.5
	.byte 2				; 94 - 47
	.byte 14			; 96 - 48
	.byte 1				; 110 - 55
	.byte 0				; 110 - 55
	.byte 255			; wait for objects
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-21] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte 0
	.byte 0
	.byte 0	
	.byte 0
	.byte 0
	.byte pat_3d_bit	
	.byte pat_3d_bit+x_mirror_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte 0
	.byte x_mirror_bit
	.byte 0
	.byte 0
	.byte 0
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte 0
	.byte 0	
	.byte pat_3d_bit+sum_bit	; must have link set as the sum pat object CAN be killed
	.byte pat_3d_bit+link_bit	; leaving the other pat going with no summing
	.byte 0
	.dc [max_patterns-21] 0	

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat13-pat0]
	.byte <[pat14-pat0]
	.byte <[pat46-pat0]	
	.byte <[pat46-pat0]
	.byte <[pat46-pat0]
	.byte <[pat35-pat0]	
	.byte <[pat35-pat0]
	.byte <[pat40-pat0]
	.byte <[pat47-pat0]
	.byte <[pat47-pat0]
	.byte <[pat48-pat0]
	.byte <[pat13-pat0]
	.byte <[pat14-pat0]
	.byte <[pat49-pat0]
	.byte <[pat43-pat0]
	.byte <[pat50-pat0]
	.byte 2				; init boss	
	.byte <[pat52-pat0]
	.byte <[pat51-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-21] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat13-pat0]*8+4-1
	.byte >[pat14-pat0]*8+4-1
	.byte >[pat46-pat0]*8+2-1
	.byte >[pat46-pat0]*8+1-1
	.byte >[pat46-pat0]*8+3-1
	.byte >[pat35-pat0]*8+2-1
	.byte >[pat35-pat0]*8+1-1
	.byte >[pat40-pat0]*8+1-1
	.byte >[pat47-pat0]*8+1-1
	.byte >[pat47-pat0]*8+1-1
	.byte >[pat48-pat0]*8+1-1
	.byte >[pat13-pat0]*8+1-1
	.byte >[pat14-pat0]*8+1-1
	.byte >[pat49-pat0]*8+3-1
	.byte >[pat43-pat0]*8+1-1
	.byte >[pat50-pat0]*8+3-1
	.byte music_bank_offset+8	; song (syura)
	.byte >[pat52-pat0]*8+1		; NB sum pattern qty is not qty-1
	.byte >[pat51-pat0]*8+8-1
	.byte 0
	.dc [max_patterns-21] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte head
	.byte head
	.byte ship
	.byte ship
	.byte ship
	.byte robot1A	
	.byte robot1B
	.byte robot3A
	.byte triadA
	.byte triadA
	.byte triadA
	.byte head
	.byte head
	.byte robot1B
	.byte robot2A
	.byte robot4A
	.byte 0
	.byte syura
	.byte tallrock
	.byte 0
	.dc [max_patterns-21] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 9
	.byte 9
	.byte 3	
	.byte 3
	.byte 3
	.byte 20	
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 3
	.byte 9
	.byte 0
	.byte 10
	.byte 0				; start song line
	.byte 128+4*8+1			; 4 hits on 1 animation frames before dying
	.byte 3
	.byte 0
	.dc [max_patterns-21] 0

