
; stage 16 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte +$ca,"STAGE"
	.byte 0,1+1,6+1
	
	.byte 0,0
	.byte +$ca,"NATURA"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+1
	.byte $28
	
; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 2

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte 128

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 128,6,6,9

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,128,128,128,128,128,128,planeA,stanray
	.byte robot7,robot4A,robot1A,antenna,tower,brick,rocket,fireball,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 62-40,62-20,62,64,66,68,70,72
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

;sky_colour		.ds 40

	.byte 8*16+4
	.byte 8*16+4,8*16+4,8*16+6,8*16+8,8*16+10,8*16+12,8*16+14,0*16+14
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 0

;grid_colour_wrap	.ds 1

	.byte 0

;grid_colour_pause	.ds 24

	.byte 255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;grid_colour1		.ds 24

	.byte 9*16+10,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour2		.ds 24

	.byte 9*16+12,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte 0
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte brick*4
	.byte tower*4
	.byte antenna*4
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 4
	.byte 8
	.byte 5
	.byte 7
	.byte 5
	.byte 12
	.byte 5
	.byte 4
	.byte 4
	.byte 4
	.byte 5
	.byte 4
	.byte 35
	.byte 23
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 4				; 4 - 2
	.byte 3				; 7 - 3.5
	.byte 5				; 12 - 6
	.byte 3				; 15 - 7.5
	.byte 8				; 23 - 11.5
	.byte 0				; 23 - 11.5			
	.byte 8				; 31 - 15.5			; 
	.byte 5				; 36 - 18			; 
	.byte 0				; 36 - 18
	.byte 8				; 44 - 22
	.byte 0				; 44 - 22
	.byte 0				; 44 - 22       
	.byte 8				; 52 - 26
	.byte 0				; 52 - 26
	.byte 7				; 59 - 29.5
	.byte 6				; 65 - 32.5
	.byte 0				; 65 - 32.5
	.byte 0				; 65 - 32.5				
	.byte 4				; 69 - 34.5
	.byte 0				; 69 - 34.5
	.byte 0				; 69 - 34.5				; 
	.byte 4				; 73 - 36.5
	.byte 9				; 82 - 41
	.byte 12			; 94 - 47
	.byte 0				; 94 - 47
	.byte 4				; 98 - 49
	.byte 0				; 98 - 49
	.byte 5				; 103 - 51.5
	.byte 1				; 104 - 52
	.byte 4				; 108 - 54
	.byte 3				; 111 - 55.5
	.byte 2				; 113 - 56.5
	.byte 2				; 115 - 57.5
	.byte 1				; 116 - 58
	.byte 3				; 119 - 59.5
	.byte 255			; wait for stanray to finish
	.byte 127			; any timer value now it's end of stage command
	.dc [max_patterns-37] 0

; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte 0
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte pat_3d_bit	
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit	
	.byte pat_3d_bit
	.byte spread_bit+pat_3d_bit
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte x_mirror_bit+pat_3d_bit+anim_mirror_bit
	.byte pat_3d_bit
	.byte 0
	.byte 0
	.byte 0
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte pat_3d_bit
	.byte x_mirror_bit+anim_mirror_bit
	.byte 0
	.byte 0
	.dc [max_patterns-37] 0

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 0
	.byte <[pat35-pat0]
	.byte <[pat35-pat0]
	.byte <[pat56-pat0]
	.byte <[pat50-pat0]
	.byte <[pat49-pat0]
	.byte <[pat49-pat0]
	.byte <[pat65-pat0]
	.byte <[pat29-pat0]
	.byte <[pat29-pat0]
	.byte <[pat39-pat0]
	.byte <[pat40-pat0]
	.byte <[pat41-pat0]
	.byte <[pat43-pat0]
	.byte <[pat43-pat0]
	.byte <[pat57-pat0]
	.byte <[pat39-pat0]	
	.byte <[pat40-pat0]
	.byte <[pat41-pat0]
	.byte <[pat39-pat0]
	.byte <[pat40-pat0]
	.byte <[pat41-pat0]
	.byte <[pat29-pat0]
	.byte <[pat29-pat0]
	.byte <[pat29-pat0]
	.byte <[pat29-pat0]
	.byte <[pat43-pat0]
	.byte <[pat43-pat0]
	.byte <[pat66-pat0]
	.byte 11			; init song
	.byte <[pat34-pat0]
	.byte <[pat67-pat0]
	.byte <[pat67-pat0]
	.byte <[pat67-pat0]
	.byte <[pat34-pat0]
	.byte <[pat50-pat0]
	.byte 1				; init next stage
	.dc [max_patterns-37] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0
	.byte >[pat35-pat0]*8+3-1
	.byte >[pat35-pat0]*8+3-1
	.byte >[pat56-pat0]*8+2-1
	.byte >[pat50-pat0]*8+3-1
	.byte >[pat49-pat0]*8+1-1
	.byte >[pat49-pat0]*8+1-1
	.byte >[pat65-pat0]*8+3-1
	.byte >[pat29-pat0]*8+1-1
	.byte >[pat29-pat0]*8+1-1
	.byte >[pat39-pat0]*8+1-1
	.byte >[pat40-pat0]*8+1-1
	.byte >[pat41-pat0]*8+1-1
	.byte >[pat43-pat0]*8+1-1
	.byte >[pat43-pat0]*8+1-1
	.byte >[pat57-pat0]*8+3-1
	.byte >[pat39-pat0]*8+1-1	
	.byte >[pat40-pat0]*8+1-1
	.byte >[pat41-pat0]*8+1-1
	.byte >[pat39-pat0]*8+1-1
	.byte >[pat40-pat0]*8+1-1
	.byte >[pat41-pat0]*8+1-1
	.byte >[pat29-pat0]*8+3-1
	.byte >[pat29-pat0]*8+3-1
	.byte >[pat29-pat0]*8+1-1
	.byte >[pat29-pat0]*8+1-1
	.byte >[pat43-pat0]*8+1-1
	.byte >[pat43-pat0]*8+1-1	
	.byte >[pat66-pat0]*8+1-1
	.byte music_bank_offset+10	; song (stanray)
	.byte >[pat34-pat0]*8+3-1
	.byte >[pat67-pat0]*8+1-1
	.byte >[pat67-pat0]*8+1-1
	.byte >[pat67-pat0]*8+1-1
	.byte >[pat34-pat0]*8+3-1
	.byte >[pat50-pat0]*8+3-1
	.byte 0
	.dc [max_patterns-37] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte robot1B
	.byte robot1A
	.byte robot6A
	.byte robot4A
	.byte robot1A
	.byte robot1B
	.byte robot6B
	.byte robot2A
	.byte robot2B
	.byte robot3B
	.byte robot3B
	.byte robot3B
	.byte robot2B
	.byte robot2A
	.byte robot7
	.byte robot3A
	.byte robot3A
	.byte robot3A
	.byte robot3B
	.byte robot3B
	.byte robot3B
	.byte robot2B
	.byte robot2A
	.byte robot2B
	.byte robot2A
	.byte robot2B
	.byte robot2A
	.byte stanray
	.byte 0
	.byte planeB
	.byte robot1A
	.byte robot3A
	.byte robot2A
	.byte planeA
	.byte robot4A
	.byte 0
	.dc [max_patterns-37] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 6
	.byte 6
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 12
	.byte 12
	.byte 12
	.byte 12
	.byte 12
	.byte 12	
	.byte 0
	.byte 0				; start song line
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 10
	.byte 0
	.dc [max_patterns-37] 0