
; stage 18 data

	*=$0000
	
	.opt no obj
	
	.include "../constants.asm"
	.include "../patterns.asm"

	.opt obj

;stage_overlay

;stage_name
;stage_name1		.ds 8
;stage_name2		.ds 8

	.byte +$ca,"STAGE"
	.byte 0,1+1,8+1
	
	.byte +$ca,"ABSYMBEL"

; song position required at stage start

;song_required		.ds 1
;song_line		.ds 1

	.byte music_bank_offset+4
	.byte 0
	
; stage speed PAL & NTSC - 0=25fps, 1=20fps, 2=17fps, 3=15fps

;stage_speed		.ds 1

	.byte 3

; stage type - bit 7 - normal, bit 7 off - top grid, bit 0-1 - uriah (counter type)

;stage_type		.ds 1

	.byte 128

; minimum length missile must travel

;missile_min_length	.ds 4		; wiwi jumbo, oval, fireball, robot missile

	.byte 5,5,5,5

; object sizes required for stage
; any empty slot must be set to negative

;size_slots		.ds max_size_slots

	.byte 128,128,128
	.byte 128,128,end,uriahseg,uriahB,uriahA,tallrock,syura,dragseg3a,drag3a
	.byte head,dragseg1a,drag1a,barbarian,purple,dragseg2a,drag2a,fireball,explosion,bullet

; sky positions and colours (the first, highest colour doesn't require a position)
; NB lowest horizon value should be used for sky position, which is max man_y divided by 2 + 4
; currently (64+42)/2 + 4 = 57. (72-57) is the lowest dli on horizon.

;sky_pos		.ds 39

	.byte 24
	.byte 26,28,30,32
	.byte 34,36,38,40
	.byte 42,44,46,48
	.byte 50,52,54,56
	.byte 58,60,62,64
	.byte 66,68,70,72
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0
	
;sky_colour		.ds 40

	.byte 4*16+12						; pink
	.byte 0+10
	.byte 8*16+12,8*16+14,8*16+12,0+10			; blue bar
	.byte 10*16+12,10*16+14,10*16+12,0+10			; green bar
	.byte 4*16+12,4*16+14,4*16+12,0+10			; pink bar
	.byte 8*16+12,8*16+14,8*16+12,0+10			; blue bar
	.byte 10*16+12,10*16+14,10*16+12,0+10			; green bar
	.byte 4*16+12,4*16+14,4*16+12,0+8;10			; pink
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0

; grid colours and colour cycling
; start should be 1 more than table entry required as a DEC is done on the fetch

;grid_colour_start	.ds 1

	.byte 6

;grid_colour_wrap	.ds 1

	.byte 5

;grid_colour_pause	.ds 24

	.byte 4,4
	.byte 4,4
	.byte 4,4,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour1		.ds 24

	.byte 7*16+12,6*16+12
	.byte 5*16+12,4*16+12
	.byte 5*16+12,6*16+12,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

;grid_colour2		.ds 24

	.byte 0*16+10,0*16+10
	.byte 0*16+10,0*16+10
	.byte 0*16+10,0*16+10,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0
	.byte 0,0,0,0

; all the objects controlled by a scenery stream are used together in a row
; if non zero one is randomly made to be missing

;scenery_row		.ds 1

	.byte 0

; scenery objects with high_bit set use sine wave like y positions if set to non-zero

;scenery_sine		.ds 1

	.byte 0

; scenery can be in a narrow x range near centre of screen for Uriah or more widely
; spaced for other stages. logical and with random number is done to give range
; x range -63 to +63, set to 127. x range -15 to +15, set to 31

;scenery_spread		.ds 1

	.byte ~01111111

; scenery streams

; control=0 means no object
; control bit 1 - object row
; control bit 0 - multi-object (ie different coloured mushrooms)
; control other bits are object type
; timer=0 means infinite wait for end of stage. timer is in seconds/2

;stream1_control	.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream1_timer		.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_control	.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

;stream2_timer		.ds 34

	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; sequencer stream

; byte 1 - timer. timer is in seconds/2 (129-255 means wait until active patterns dead)

;stream_timer		.ds max_patterns

	.byte 1				; godarni
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 255			; wait for objects

	.byte 1				; barbarian
	.byte 0 
	.byte 255			; wait for objects
	
	.byte 1				; squilla
	.byte 0
	.byte 255			; wait for objects
	
	.byte 1				; ida
	.byte 0
	.byte 0
	.byte 0
	.byte 255			; wait for objects
	
	.byte 1				; salpedon
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.byte 255			; wait for objects
	
	.byte 1				; syura
	.byte 0
	.byte 255			; wait for objects
	
	.byte 1				; valda
	.byte 0
	.byte 255			; wait for objects
	
	.byte 1				; speed up
	.byte 5				; uriah
	.byte 0				; slow down
	.byte 26
	
	.byte 102 			; "the end" graphic
	.byte 127			; end game
	.dc [max_patterns-35] 0


; byte 2 - properties (when no object then pattern command required)

;stream_properties
;stream_pat_command	.ds max_patterns

	.byte 0
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+sum_bit+rotate_bit
	
	.byte 0	
	.byte pat_3d_bit+sum_bit	; must have link set as the sum pat object CAN be killed
	.byte pat_3d_bit+link_bit	; leaving the other pat going with no summing
	
	.byte 1				; priority swap pattern command
	.byte animate_bit
	.byte link_bit+animate_bit

	.byte 2				; reset sum loop pattern command
	.byte pat_3d_bit+sum_bit
	.byte pat_3d_bit+link_bit
	.byte pat_3d_bit
	.byte pat_3d_bit+spread_bit

	.byte 0
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+animate_bit
	.byte pat_3d_bit+link_bit+animate_bit
	.byte pat_3d_bit+sum_bit+rotate_bit

	.byte 0	
	.byte pat_3d_bit+sum_bit	; must have link set as the sum pat object CAN be killed
	.byte pat_3d_bit+link_bit	; leaving the other pat going with no summing
	
	.byte 1				; priority swap pattern command
	.byte animate_bit+x_mirror_bit
	.byte link_bit+animate_bit+x_mirror_bit
	
	.byte 0
	.byte 0
	.byte 7				; man off command
	.byte 0
	
	.byte 0
	.byte 0
	.dc [max_patterns-35] 0

; byte 3 - pattern offset lo (when no object then game command required)

;stream_pat_lo
;stream_game_command	.ds max_patterns

	.byte 2				; init boss
	.byte <[pat24-pat0]
	.byte <[pat25-pat0]
	.byte <[pat27-pat0]
	.byte <[pat28-pat0]
	.byte <[pat26-pat0]

	.byte 2				; init boss	
	.byte <[pat52-pat0]
	.byte <[pat51-pat0]
	
	.byte 2				; init boss
	.byte <[pat8-pat0]
	.byte <[pat9-pat0]

	.byte 2				; init boss
	.byte <[pat16-pat0]
	.byte <[pat15-pat0]
	.byte <[pat17-pat0]
	.byte <[pat18-pat0]
	
	.byte 2				; init boss
	.byte <[pat24-pat0]
	.byte <[pat25-pat0]
	.byte <[pat27-pat0]
	.byte <[pat28-pat0]
	.byte <[pat26-pat0]

	.byte 2				; init boss	
	.byte <[pat52-pat0]
	.byte <[pat51-pat0]
	
	.byte 2				; init boss
	.byte <[pat8-pat0]
	.byte <[pat9-pat0]
	
	.byte 10			; set stage speed
	.byte 14			; uriah
	.byte 10			; set stage speed
	.byte <[pat72-pat0]

	.byte <[pat73-pat0]
	.byte 15			; end game
	.dc [max_patterns-35] 0

; byte 4 - bit 3-7 - pattern offset hi
; byte 4 - bit 0-2 - object qty (for sum patterns 0-7, for normal patterns 1-8)
; byte 4 - (when no object then game command music required)

;stream_pat_hi
;stream_qty
;stream_game_arg1	.ds max_patterns

	.byte 0				; no song (done by init_stage)
	.byte >[pat24-pat0]*8+1-1
	.byte >[pat25-pat0]*8+3-1
	.byte >[pat27-pat0]*8+1-1
	.byte >[pat28-pat0]*8+3-1
	.byte >[pat26-pat0]*8+1

	.byte music_bank_offset+8	; song (syura)
	.byte >[pat52-pat0]*8+1		; NB sum pattern qty is not qty-1
	.byte >[pat51-pat0]*8+8-1
	
	.byte music_bank_offset+2	; song (squilla)
	.byte >[pat8-pat0]*8+1-1
	.byte >[pat9-pat0]*8+7-1

	.byte music_bank_offset+3	; song (ida)
	.byte >[pat16-pat0]*8+0
	.byte >[pat15-pat0]*8+1-1
	.byte >[pat17-pat0]*8+4-1
	.byte >[pat18-pat0]*8+6-1

	.byte music_bank_offset+4	; song (godarni)
	.byte >[pat24-pat0]*8+1-1
	.byte >[pat25-pat0]*8+3-1
	.byte >[pat27-pat0]*8+1-1
	.byte >[pat28-pat0]*8+3-1
	.byte >[pat26-pat0]*8+1

	.byte music_bank_offset+8	; song (syura)
	.byte >[pat52-pat0]*8+1		; NB sum pattern qty is not qty-1
	.byte >[pat51-pat0]*8+8-1
	
	.byte music_bank_offset+9	; song (valda)
	.byte >[pat8-pat0]*8+1-1
	.byte >[pat9-pat0]*8+7-1
	
	.byte 1				; 20 fps
	.byte music_bank_offset+11	; song (lakeside)
	.byte 3				; 15 fps
	.byte >[pat72-pat0]*8+6-1	
	
	.byte >[pat73-pat0]*8+1-1
	.byte 0
	.dc [max_patterns-35] 0

; byte 5 - object type (0 means no objects - a non-pattern game command)

;stream_object		.ds max_patterns

	.byte 0
	.byte drag2a
	.byte dragseg2a
	.byte drag2a
	.byte dragseg2a
	.byte dragseg2a

	.byte 0
	.byte barbarian
	.byte purple
	
	.byte 0
	.byte drag1a
	.byte dragseg1a
	
	.byte 0
	.byte 255			; this must be non-zero for sum pattern, even if object qty 0
	.byte barbarian
	.byte head
	.byte head

	.byte 0
	.byte drag3a
	.byte dragseg3a
	.byte drag3a
	.byte dragseg3a
	.byte dragseg3a

	.byte 0
	.byte syura
	.byte tallrock
	
	.byte 0
	.byte drag3A
	.byte dragseg3A

	.byte 0	
	.byte 0
	.byte 0
	.byte uriahA+128		; bit 7 - other object bit
	
	.byte end
	.byte 0
	.dc [max_patterns-35] 0

; byte 6 - object spacing
; byte 6 - when bit 7 - hit count patterm
; byte 6 - also bit 3-6 - qty of hits before animation or actions (when a hit count pattern)
; byte 6 - also bit 0-2 - qty of animation frames or actions (when a hit count pattern)

;stream_spacing
;stream_game_arg2	.ds max_patterns

	.byte 0
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 0

	.byte 0				; start song line
	.byte 128+4*8+1			; 4 hits on 1 animation frames before dying
	.byte 3
	
	.byte 0				; start song line
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3

	.byte 0				; start song line
	.byte 0
	.byte 0
	.byte 5
	.byte 3
	
	.byte 0				; start song line
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	.byte 0

	.byte 0				; start song line
	.byte 128+4*8+1			; 4 hits on 1 animation frames before dying
	.byte 3
	
	.byte 0				; start song line
	.byte 128+5*8+2			; 5 hits on 2 animation frames before dying
	.byte 3
	
	.byte 0
	.byte 0				; start song line
	.byte 0
	.byte 3
	
	.byte 0
	.byte 0
	.dc [max_patterns-35] 0